<template>
    <div class="app-container">
        <div class="head-container">
            <el-row :gutter="20">
                <el-col :span="6">
                    <el-input v-model="query.blurry" size="small" clearable placeholder="请输入单位名称" style="width: 100%;"
                        class="filter-item" @keyup.enter.native="toQuery" />
                </el-col>
                <el-col :span="6">
                    <el-button type="primary" @click="toQuery">查询</el-button>
                    <el-button @click="resetHandle">重置</el-button>
                </el-col>
            </el-row>
        </div>
        <div class="head-container">
            <el-button type="primary" icon="el-icon-plus" @click="$refs.addUnitRef.show()">添加单位</el-button>
            <addUnit ref="addUnitRef" @success="getTableData()" />
        </div>
        <div class="head-container">
            <el-table :data="tableData.list" v-loading="tableData.loading">
                <el-table-column label="单位名称" prop="name"></el-table-column>
                <el-table-column label="排序" prop="id" sortable></el-table-column>
                <el-table-column label="操作" width="200">
                    <template v-slot="scope">
                        <el-button type="text" size="mini" round icon="el-icon-edit"
                            @click="$refs.addUnitRef.show(scope.row)">编辑</el-button>
                        <el-popconfirm title="确定删除吗？" @confirm="delHandle([scope.row.id])">
                            <el-button type="text" size="mini" round icon="el-icon-delete" slot="reference">删除</el-button>
                        </el-popconfirm>
                    </template>
                </el-table-column>
            </el-table>
        </div>
        <div class="head-container">
            <el-pagination :total="tableData.total" :current-page="tableData.page + 1" :page-size="tableData.size"
                @current-change="paginationChange" layout="total, sizes, prev, pager, next, jumper"></el-pagination>
        </div>
    </div>
</template>

<script>
import { tbShopCurrencyGet, tbShopUnitDelete } from '@/api/shop'
import addUnit from './components/addUnit'
export default {
    components: {
        addUnit
    },
    data() {
        return {
            query: {
                blurry: ''
            },
            tableData: {
                page: 0,
                size: 10,
                total: 0,
                loading: false,
                list: []
            }
        }
    },
    mounted() {
        this.getTableData()
    },
    methods: {
        // 查询table
        toQuery() {
            this.getTableData()
        },// 重置查询
        resetHandle() {
            this.tableData.page = 0;
            this.query.blurry = ''
            this.getTableData()
        },
        // 分页回调
        paginationChange(e) {
            this.tableData.page = e - 1;
            this.getTableData()
        },
        // 删除
        async delHandle(ids) {
            try {
                await tbShopUnitDelete(ids)
                this.$notify({
                    title: '成功',
                    message: `删除成功`,
                    type: 'success'
                });
                this.getTableData()
            } catch (error) {
                console.log(error)
            }
        },
        // 获取商品列表
        async getTableData() {
            this.tableData.loading = true
            try {
                const res = await tbShopCurrencyGet({
                    page: this.tableData.page,
                    size: this.tableData.size,
                    sort: 'id',
                    shopId: localStorage.getItem('shopId'),
                    name: this.query.blurry
                })
                this.tableData.loading = false
                this.tableData.list = res.content
                this.tableData.total = res.totalElements
            } catch (error) { }
        }
    }
}
</script>